\ time.f        - isforth time functions
\ ------------------------------------------------------------------------

.( loading time.f ) cr

\ ------------------------------------------------------------------------

\ figured all this *%^& out - someone let me know if this method is flawed

\ ------------------------------------------------------------------------
\ 4 years worth of days per month

<headers

create dpm
  31 c, 28 c, 31 c, 30 c, 31 c, 30 c,
  31 c, 31 c, 30 c, 31 c, 30 c, 31 c,
  31 c, 28 c, 31 c, 30 c, 31 c, 30 c,
  31 c, 31 c, 30 c, 31 c, 30 c, 31 c,
  31 c, 28 c, 31 c, 30 c, 31 c, 30 c,
  31 c, 31 c, 30 c, 31 c, 30 c, 31 c,
  31 c, 29 c, 31 c, 30 c, 31 c, 30 c,   \ leap year
  31 c, 31 c, 30 c, 31 c, 30 c, 31 c,

\ ------------------------------------------------------------------------

create days     ,' SunMonTueWedThrFriSat'
create months   ,' JanFebMarAprMayJunJulAugSepOctNovDec'

headers>

create time$    ," 00:00:00"
create day$     ," ---"

 0 var year                  \ current year
 0 var month                 \ current month
 0 var day                   \ current day of the month

\ ------------------------------------------------------------------------
\ construct time string

: time>$        ( #seconds-since-epoc --- #days-since-epoc )
  time$ count + hld !       \ compile time $
  (t) (t)                   \ extract seconds and minutes
  24 /% swap 0
  # # 2drop ;               \ kludge because #> assumes hld points to pad

\ ------------------------------------------------------------------------

<headers

: (year)
  1970 !> year              \ current year is epoch plus....
  12                        \ index into 48 month dpm table
  begin
    dup dpm + c@            \ get number of days in current month
    pluck > not             \ while # days since epoc is more than this
  while 
    dup dpm + c@            \ subtract number of days in current month
    rot swap -              \ from the number of days since the epoc
    swap 1+                 \ increment month index into dpm table
    dup 47 >                \ reached end of 4 years worth ?
    if 
      drop 0                \ yes - reset to start of table
      4 +!> year            \ add 4 to year
    then
  repeat 
  12 /%                     \ might be on year 1 2 or 3 here so extract
  +!> year                  \ year and add (leaves month)
  decr> year ;

\ the epoc started at the beinning of the year 1970 which is 3 years from
\ a leap year so we had to index into the days per month table on the    
\ second year.  when we see oour first leap year we wil add 4 years to the
\ total years which is incorrect - the last thing we do above is decrement
\ the year to fix this


headers>

\ ------------------------------------------------------------------------
\ it only took me 2 days to figure out how to get all this crap 

: date@
  time@                     \ get # seconds since epoc
  tz @ 60 * -               \ get current time and timezone offset
  time>$                    \ construct time string

\ we now have the number of days since the epoch at top of stack

  dup
  7 /% drop 3 -           \ extract day of the week
  dup 0< 7 and +  
  3 * days +
  day$ 1+ 3 cmove           \ make day$ reflect current day of the week

  (year)

  !> month                  \ set current month
  1+ !> day ;               \ make day not zero based :)

\ ------------------------------------------------------------------------

: .date
  base @ decimal
  date@ 
  day$ count type ',' emit space
  day 0 <# # # #> type space
  month 3 * months + 3 type space
  year . 
  time$ count type space
  tz @ dup abs 10 6 */
  0 <# # # # # rot 
  0< if '+' else '-' then
  hold #> type 
  base ! ;

\ ------------------------------------------------------------------------

behead

\ ========================================================================  
