\ keys.f          - isforth terminal keyboard handler main source file
\ ------------------------------------------------------------------------

 .( loading keys.f ) cr

\ ------------------------------------------------------------------------

 terminal definitions

\ ------------------------------------------------------------------------
\ key sequence input buffer address

<headers

 0 var keybuff

\ ------------------------------------------------------------------------
\ allocate key sequence buffer at run time

: alloc-keybuff
  defers default
  20 ?alloc !> keybuff ;    \ keyboard sequence buffer

\ ------------------------------------------------------------------------
\ append char to keybuff

: >keybuff          ( c1 --- )
  keybuff dup>r 
  count dup>r + c!
  r> 1+ r> c! ;

\ ------------------------------------------------------------------------
\ return single key or sequence of keys (maybe an escape sequence)

: read-keys
  keybuff off               \ zero out keyboard read buffer
  (key) >keybuff            \ read one key to buffer
  begin                     \ if keys still ready assume not user typed
    key?                    \ are there keys still available ?
  while
    (key) >keybuff          \ store them in the buffer
  repeat ;

headers>

\ ------------------------------------------------------------------------

 forth definitions

\ ========================================================================
