\ debug.f       - isforth debugger load screen
\ ------------------------------------------------------------------------

 .( Loading debugger ) cr

\ ------------------------------------------------------------------------

 debug definitions
 
\ ------------------------------------------------------------------------

-headers

<headers

 0 var bug-sp               \ debug parameter stack pointer
 0 var bug-rp               \ debug return stack pointer
 0 var bug-ip               \ debug interprative pointer

\ ------------------------------------------------------------------------

: alloc-stack       ( --- a1 )
  4096 allocate ?exit
  true abort" Cannot allocate debug stacks" ;
 
\ ------------------------------------------------------------------------

: allocate-stacks
  bug-sp ?exit
  alloc-stack !> bug-sp
  alloc-stack !> bug-rp ;

\ ------------------------------------------------------------------------

: free-stacks
  bug-sp free drop off> bug-sp
  bug-rp free drop off> bug-rp ;
  
\ ------------------------------------------------------------------------

 fload src/debug/bugwin.f   \ debugger window display
 fload src/debug/bugkey.f   \ keyboard handlers

\ ------------------------------------------------------------------------

 behead forth definitions

\ ========================================================================
