\ keytest.f     isforth example key handler
\ ------------------------------------------------------------------------

: kk-bs      ." Backspace" cr ;
: kk-del     ." Delete" cr ;
: kk-down    ." Down" cr ;
: kk-f1      ." F1" cr ;
: kk-f10     ." F10" cr ;
: kk-f2      ." F2" cr ;
: kk-f3      ." F3" cr ;
: kk-f4      ." F4" cr ;
: kk-f5      ." F5" cr ;
: kk-f6      ." F6" cr ;
: kk-f7      ." F7" cr ;
: kk-f8      ." F8" cr ;
: kk-f9      ." F9" cr ;
: kk-home    ." Home" cr ;
: kk-insert  ." Insert" cr ;
: kk-left    ." Left" cr ;
: kk-pdown   ." Page Down" cr ;
: kk-pup     ." Page Up" cr ;
: kk-right   ." Right" cr ;
: kk-up      ." Up" cr ;
: kk-btab    ." Back Tab" cr ;
: kk-end     ." End" cr ;
: kk-enter   ." Enter" cr ;
: kk-sdel    ." Shifted Delete" cr ;
: kk-send    ." Shifted End" cr ;
: kk-shome   ." Shifted Home" cr ;
: kk-sleft   ." Shifted Left" cr ;
: kk-spdn    ." Shifted Page Down" cr ;
: kk-spup    ." Shifted Page Up" cr ;
: kk-sright  ." Shifted Right" cr ;
: kk-f11     ." F11" cr ;
: kk-f12     ." F12" cr ;

\ ------------------------------------------------------------------------

create old-actions 32 4* allot

create new-actions
]
  kk-bs    kk-del   kk-down  kk-f1   kk-f10  kk-f2     kk-f3     kk-f4
  kk-f5    kk-f6    kk-f7    kk-f8   kk-f9   kk-home   kk-insert kk-left
  kk-pdown kk-pup   kk-right kk-up   kk-btab kk-end    kk-enter  kk-sdel
  kk-send  kk-shome kk-sleft kk-spdn kk-spup kk-sright kk-f11    kk-f12
[

create key-values
  key-bs    , key-del    , key-down   , key-f1   ,
  key-f10   , key-f2     , key-f3     , key-f4   ,
  key-f5    , key-f6     , key-f7     , key-f8   ,
  key-f9    , key-home   , key-insert , key-left ,
  key-pdown , key-pup    , key-right  , key-up   ,
  key-btab  , key-end    , key-enter  , key-sdel ,
  key-send  , key-shome  , key-sleft  , key-spdn ,
  key-spup  , key-sright , key-f11    , key-f12  ,


\ ------------------------------------------------------------------------

: set-actions
  32 0
  do
    i 4* dup>r
    new-actions + @
    key-values r@ + @
    key-action
    old-actions r> + !
  loop ;

\ ------------------------------------------------------------------------

: reset-actions
  32 0
  do
    i 4* dup>r
    old-actions + @
    key-values r> + @
    key-action drop
  loop ;

\ ------------------------------------------------------------------------

: keytest
  cr cr
  set-actions
  ['] key >body @ >r
  ['] newkey is key
  begin
    key 
    dup emit
    'x' =
  until
  cr cr
  r> is key
  reset-actions ;

\ ========================================================================
