\ env.f         - isforth environment searching
\ ------------------------------------------------------------------------

.( loading env.f ) cr

\ ------------------------------------------------------------------------
\ compare string to environment var

: env= ( env a1 --- f1 )
  2dup count comp           \ compare string at a1 with env var's name.
  >r c@ + c@ '=' = r> and ; \ also, check that next char is '='.


\ ------------------------------------------------------------------------
\ search environment for variable whose name is at a1

: getenv    ( a1 --- a1 n1 true | false )
  envp swap                 \ point at start of environment table
  begin
    over @ over             \ copy a1 and envp
	env=                    \ right environment var ?
    if                      \ same ?
      c@ 1+ swap @ +
      dup scanz over -
      true exit
    then
    swap 4+ tuck            \ not same - go to next env var.
    @ 0=                    \ is there another env var ?
  until 
  2drop false ;             \ no - discard a1 and envp and return false 

\ ========================================================================
