\ status.f      - isforth displays status in top line
\ ------------------------------------------------------------------------

.( loading status.f ) cr

\ ------------------------------------------------------------------------

 forth definitions

\ ------------------------------------------------------------------------

<headers

 false var status           \ status is off/on ?

headers>

\ ------------------------------------------------------------------------
\ turn status line on - set scroll region below status line

: staton        ( --- )
  on> status                \ we are displaying status info now
  sc 1 rows 1- csr          \ set scroll region
  rc ;

\ ------------------------------------------------------------------------
\ turn status line off - scroll through status line is ok now

: statoff       ( --- )
  off> status               \ status not being displayed
  sc 0 rows 1- csr          \ set scroll region
  rc ;

\ ------------------------------------------------------------------------
\ display free list space, display free head space

: .lfree tlist here  - 7 .r ;
: .hfree thead hhere - 7 .r ;

\ ------------------------------------------------------------------------

<headers

create statline
 ,"  List        Head        Depth      Base   "

\ ------------------------------------------------------------------------
\ display status line in row 1

headers>

: (.status)
  status 0= ?exit           \ is status enabled ?
  floads @ ?exit            \ no status update during fload

  sc #out @ #line @ 
  base @ dup>r fg bg pref

  off> pref blue !> bg 
  white !> fg >pref 0 0 at 

  decimal curoff 
  statline count type
  yellow !> fg >bold
  5  hpa .lfree 17 hpa .hfree
  31 hpa depth 6 - 4 .r 
  41 hpa r> 2 .r space
  green >fg .date
  cols #out @ - 1- spaces

  curon !> pref !> bg !> fg
  base ! #line ! #out ! >pref
  rc ;

' (.status) is .status

\ ------------------------------------------------------------------------

<headers
 
: instat  defers default intty? not ?exit staton ;
: outstat defers atexit status 0= ?exit statoff ;

\ ------------------------------------------------------------------------

behead

\ ========================================================================
