\ words.f       - isforth vocabulary listing words
\ ------------------------------------------------------------------------

.( loading words.f ) cr

\ ------------------------------------------------------------------------

\ If enough people request that I add color to different word types and
\ can tell me how to colorize user defined word classes I might do it :P
\
\ might also add substring searches so we can find all words that contain
\ a substring... eventually

\ ------------------------------------------------------------------------

<headers

: l++ cr ?more ;

: l+++
  l++ mkey $1b = 
  l++ mkey $1b = or ;

\ ------------------------------------------------------------------------
\ display all words in specified vocabulary (from each thread)

: (words)       ( vocabulary --- )
  #threads 4* bounds        \ byte size of vocabularies thread array
  do
    i @ ?dup                \ get address from thread. is it null ?
    if
      begin
        dup (.id)           \ keep copy of current nfa address
        n>link @ dup 0=     \ scan 4 bytes back from nfa = lfa
        mkey $1b = or
      until                 \ fetch lfa - if not 0 then repeat
      drop                  \ else do one more new line and clean up
    then
    mkey $1b = ?leave
  4 +loop ;                 \ advance to next thread

\ ------------------------------------------------------------------------
\ display all words in context

headers>

: words
  rows 3 - !> idx0
  cols !> idw                   \ set max width (see utils.f)
  idx0 !> idx
  ['] cr is .idcr
  cr cr white >fg <bold
  context dcount 4* bounds      \ for each vocabulary in context array
  do
    i @                         \ get address of vocabulary
    dup 8 - @                   \ get nfa of vocabulary name 
    count lexmask               \ and display it within [ and ] chars
    >bold
    '[' emit type ']' emit
    <bold
    l+++ ?leave
    (words)                     \ display all words in this vocabulary
    mkey $1b = ?leave
    l+++ ?leave
  4 +loop ;

\ ------------------------------------------------------------------------

behead

\ ========================================================================
