
 rehash cr

fload src/ext/comment.f         \ + commenting words
fload src/ext/loops.f           \ + loop and branch compilation words
fload src/ext/variable.f        \ + variable creating words etc
fload src/ext/header.f          \ + headerless word creation
fload src/ext/fsave.f           \ + turnkey and fsave

\ ------------------------------------------------------------------------
\ optional but much of the below relies on these

fload src/ext/struct.f          \ * structure definition words
fload src/ext/list.f            \ * linked list words
fload src/ext/memory.f          \ * memory allocation and deallocation

\ ------------------------------------------------------------------------

fload src/ext/error.f           \ * not catch/throw (puke)
fload src/ext/env.f             \ * environment searching
fload src/ext/case.f            \ * case statements
fload src/ext/number.f          \ * pictured number output
fload src/ext/file.f            \ * file i/o
fload src/ext/timer.f           \ * delays and elapsed time measurement
fload src/ext/time.f            \ * displaying time and timing things
fload src/ext/rnd.f             \ * random number generator
fload src/ext/args.f            \ * command line args primatives
fload src/ext/inline.f          \ * macro colon definitions
fload src/ext/utils.f           \ * usefull stuff to have arround

\ ------------------------------------------------------------------------
\ terminfo handling

-headers        \ disable beheading so we can debug this
fload src/terminal/term.f       \ * curses without the cussing
fload src/terminal/terminfo.f   \ terminfo parsing etc
fload src/terminal/color.f      \ colour output
fload src/terminal/keys.f       \ common keyboard handler code
  \ these are a work in progress...
\ fload src/terminal/t-keys.f     \ terminfo key sequence handlers
\ fload src/terminal/z-keys.f     \ more extensive key recognition
behead forth definitions
+headers        \ re-enable beheading

fload src/terminal/tui/tui.f    \ * text user interface (aka curses)

\ ------------------------------------------------------------------------
\ block file extensions

\ fload src/ext/block.f           \ * block file wordset
\ fload src/ext/bload.f           \ - block file interpret words
\ fload src/ext/bedit.f           \ - block file editor

\ ------------------------------------------------------------------------
\ sockets related (work in progress but useable - no dns yet :)

\ fload src/ext/sockets.f         \ * socket connect/read/write
\ fload src/ext/resolver.f        \ * dns queries

\ ------------------------------------------------------------------------

fload src/ext/words.f           \ - vocabulary listings
fload src/ext/forget.f          \ - forget, empty etc
fload src/ext/meminfo.f         \ - display info about allocated mem
fload src/ext/hello.f           \ - nice signon message
fload src/ext/status.f          \ - status line display
fload src/ext/tail.f            \ - default args handler

\ ------------------------------------------------------------------------
\ decompiler and debugger

fload src/debug/see.f           \ - decompiler
\ fload src/debug/debug.f         \ - the debugger ( requires see.f )

  \ behead forth definitions

\ ------------------------------------------------------------------------
\ +     required files
\ *     optional files
\ -     dont include in turnkey apps
\ ------------------------------------------------------------------------

\ ------------------------------------------------------------------------
\ save out extended forth - does not return - implied bye

cr .( writing extended compiler )

 fsave isforth 

\ ========================================================================
